using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Collections;

namespace QuellcodeAuswertung
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Startwerte
            textBoxZielordner.Text = "C:\\kohnle\\Auswertung";
        }
        private void buttonZielordner_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog dlg = new FolderBrowserDialog();
            dlg.SelectedPath = textBoxZielordner.Text;
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                textBoxZielordner.Text = dlg.SelectedPath;
            }
        }

        private void textBoxZielordner_TextChanged(object sender, EventArgs e)
        {
            listeFuellen();
        }

        private void buttonAuswerten_Click(object sender, EventArgs e)
        {
            //*******************************
            // Extensions
            //*******************************
            ArrayList extensions = new ArrayList();
            if (checkBoxC.Checked)
                extensions.Add(".c");
            if (checkBoxCpp.Checked)
                extensions.Add(".cpp");
            if (checkBoxH.Checked)
                extensions.Add(".h");
            if (checkBoxCs.Checked)
                extensions.Add(".cs");
            if (checkBoxJava.Checked)
                extensions.Add(".java");

            // Verzeichnis
            DirectoryInfo verzeichnis = new DirectoryInfo(textBoxZielordner.Text);

            // alle Projektverzeichnisse
            foreach (DirectoryInfo projektVerzeichnis in verzeichnis.GetDirectories())
            {
                // Auswertungsdatei erstellen
                StreamWriter auswertungsdatei = new StreamWriter(verzeichnis.FullName + "\\" + projektVerzeichnis.Name + ".txt");
                

                // Verzeichnisname als Hauptueberschrift
                auswertungsdatei.WriteLine("***********************************");
                auswertungsdatei.WriteLine("     " + projektVerzeichnis.Name);
                auswertungsdatei.WriteLine("***********************************");

                // alle Quellcodedateien
                foreach (FileInfo quelldatei in projektVerzeichnis.GetFiles())
                {
                    // alle Extensions
                    foreach (String typ in extensions)
                    {
                        if(quelldatei.Name.EndsWith(typ)){
                            // Dateiname als Unterueberschrift 
                            auswertungsdatei.WriteLine();
                            auswertungsdatei.WriteLine("+++++++++++++++++++++++++++++++++++");
                            auswertungsdatei.WriteLine("     " + quelldatei.Name);
                            auswertungsdatei.WriteLine("+++++++++++++++++++++++++++++++++++");
                            // Dateiinhalt  
                            StreamReader lesedatei = new StreamReader(quelldatei.FullName);
                            string inhalt = lesedatei.ReadToEnd();
                            lesedatei.Close();
                            auswertungsdatei.Write(inhalt);
                        }
                    }
                }

                // Datei schliessen
                auswertungsdatei.Close();

            }

            //Liste fuellen
            listeFuellen();
        }

        private void listeFuellen()
        {
            //*********************************
            //    Liste fuellen
            //*********************************
            listBoxZielordner.Items.Clear();
            try
            {
                // Verzeichnis
                DirectoryInfo verzeichnis = new DirectoryInfo(textBoxZielordner.Text);

                // alle Projektverzeichnisse
                foreach (DirectoryInfo projektVerzeichnis in verzeichnis.GetDirectories())
                {
                    listBoxZielordner.Items.Add(projektVerzeichnis.Name + "\\");
                }
                // alle Dateien
                foreach (FileInfo datei in verzeichnis.GetFiles())
                {
                    listBoxZielordner.Items.Add(datei.Name);
                }
            }
            catch
            {
            }
        }

        

           

        
    }
}